/*******************************************************************************

Copyright (c) 2008 - 2018 ӢʱƼ޹˾Ȩ

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef unsigned char BYTE;
typedef long BOOL;

#define FALSE	0
#define TRUE	1


#define MAX_LINE_LENGTH		256		// һджٸַ
#define MAX_LINE_COUNT		1024	// Դļж

#define MAX_SYMBOL_LENGTH	64		// һ԰ٸַ
#define MAX_SYMBOL_COUNT	256		// Դļ԰ٸ

#define MAX_INSTR_KEY_WORD_LENGTH	32		// һָؼ԰ٸַ

#ifndef MAX_PATH
#define MAX_PATH 256				// ļ·԰ٸַ
#endif


// ݿ⡣¼ԴļдеϢעСУ
struct LINE_RECORD
{
	char line_string[MAX_LINE_LENGTH];	// е
	unsigned long line_num;				// к
	unsigned long address;				// дתĻӳļеĵַƫƣ
	int machine_code_count;				// дתĻֽ
	unsigned long flag;					// б־λ32λ
};
struct LINE_RECORD line_database[MAX_LINE_COUNT] = {0};
int line_count = 0;
int machine_code_line_count = 0;	// ¼˻Ĵе

// ڴ˶еĴб־λע⣬б־λǰλĹϵ
#define LF_INSTRUCTION	0x00000001		// б־λλ1ʾһָʾ


// ضλָʹ˱šȷţڵһɨʱ޷ȷǵĵַҪ
// ڵڶɨʱضλ
struct REALLOCATE
{
	unsigned long address;					// һɨʱ¼ҪضλĻĵַƫƣ
											// ڶɨʱݷŵĵַضλ
	char symbol_name[MAX_SYMBOL_LENGTH];	// Ҫضλķơ
	int line_num;							// кš

	char instr_key_word[MAX_INSTR_KEY_WORD_LENGTH];				// ָؼ
};

struct REALLOCATE reallocate_table[MAX_LINE_COUNT] = {0};
int reallocate_count = 0;


// űŰԴеıš
struct SYMBOL
{
	char name[MAX_SYMBOL_LENGTH];			// 
	unsigned long address;					// űʾĵַضλʱҪõ
	int machine_code_count;					// ɵĻֽΪλ
	int line_num;							// к
	int ref_count;							// ü
};
struct SYMBOL symbol_table[MAX_SYMBOL_COUNT] = {0};
int symbol_count = 0;


// ̵״̬
enum
{
	AS_BEGIN	// ʼ״̬ǰڴ״̬
	,AS_TEXT	// ڴΡƺݵǰڴ״̬
	,AS_DATA	// ڴݶΡݶƺ󣬴ڴ״̬
};
unsigned long assembler_state = AS_BEGIN;

//
// 涨еĹؼ
//

// 
const char* code_section_keyword = ".text";		// α־
char const* data_section_keyword = ".data";		// ݶα־

// ָ

// Rָ
const char* or_instruction_keyword = "or";
const char* and_instruction_keyword = "and";
const char* add_instruction_keyword = "add";
const char* sub_instruction_keyword = "sub";
const char* sllv_instruction_keyword = "sllv";
const char* srlv_instruction_keyword = "srlv";
const char* srav_instruction_keyword = "srav";
const char* slt_instruction_keyword = "slt";

const char* jr_instruction_keyword = "jr"; // jr rs תĴPC=[rs]
const char* jalr_instruction_keyword = "jalr"; // jalr rs תӼĴ$ra = PC+2PC=[rs]

const char* sll_instruction_keyword = "sll";
const char* srl_instruction_keyword = "srl";
const char* sra_instruction_keyword = "sra";
const char* xor_instruction_keyword = "xor";
const char* nor_instruction_keyword = "nor";

// Iָ
const char* ori_instruction_keyword = "ori";
const char* andi_instruction_keyword = "andi";
const char* addi_instruction_keyword = "addi";
const char* lw_instruction_keyword = "lw";
const char* sw_instruction_keyword = "sw";
const char* beq_instruction_keyword = "beq";
const char* bne_instruction_keyword = "bne";
const char* bgt_instruction_keyword = "bgt";
const char* bltz_instruction_keyword = "bltz";// bltz rs, lable rsС0ת
const char* bgez_instruction_keyword = "bgez";// bgez rs, lable rsڻ0ת

// Jָ
const char* jump_instruction_keyword = "jump";
const char* jal_instruction_keyword = "jal"; // jal lable תӣ$ra = PC+2,PC=תĿַ


// ͨüĴ
const char* r0_register_keyword = "$r0";
const char* r1_register_keyword = "$r1";
const char* r2_register_keyword = "$r2";
const char* r3_register_keyword = "$r3";

const char* ra_register_keyword = "$ra"; // صַĴ
const char* t0_register_keyword = "$t0"; // 0Ĵ


const char* delimit_char = "\n\t\r ";			// ҪԵĿհַ
const char* delimit_char_comma = "\n\t\r, ";	// ҪԵĿհַӢĶ

// Ļ
#define MAX_MACHINE_CODE 1024
BYTE machine_code[MAX_MACHINE_CODE];
unsigned long machine_code_address = 0;
unsigned long machine_code_old_address = 0;


const char* assembly_file_name = NULL;			// ļ·
const char* target_file_name = NULL;			// Ŀļ·
const char* list_file_name = NULL;				// бļ·
const char* dbg_file_name = NULL;				// Ϣļ·

const unsigned long dbg_file_magic = 58;
const unsigned long dbg_file_version = 1;


// зֵ﷨Ϣ
void error_msg(const char* error_msg, int line_num)
{
	if(line_num >= 1)
	{
		printf("%s:%d: error: %s\n", assembly_file_name, line_num, error_msg);
	}
	else
	{
		printf("%s: error: %s\n", assembly_file_name, error_msg);
	}

	exit(1);
}

char formated_msg[1024];	// ʽĴϢڴַС
void error_msg_warning_instr(const char* instruction_name, int line_num)
{
	sprintf(formated_msg, "%s ָ΢ûʵ֣ȷִС", instruction_name);
	error_msg(formated_msg, line_num);
}

void error_msg_miss_op(const char* instruction_name, int line_num)
{
	sprintf(formated_msg, "%s ָȱٲ", instruction_name);
	error_msg(formated_msg, line_num);
}

void error_msg_wrong_op(const char* instruction_name, int line_num)
{
	sprintf(formated_msg, "%s ָ֧Ĳ", instruction_name);
	error_msg(formated_msg, line_num);
}

void error_msg_same_symbol(const char* symbol, int line_num, int ref_line_num)
{
	sprintf(formated_msg, " %s ظ塣μ %d С", symbol, ref_line_num);
	error_msg(formated_msg, line_num);
}

void error_msg_keyword_symbol(const char* symbol, int line_num)
{
	sprintf(formated_msg, "ʹñĹؼ %s Ϊơ", symbol);
	error_msg(formated_msg, line_num);
}

void error_msg_wrong_data(const char* data, int line_num)
{
	sprintf(formated_msg, "%s Чݡ", data);
	error_msg(formated_msg, line_num);
}

// зֵľϢ
void warning_msg(const char* warning_msg, int line_num)
{
	if(line_num >= 1)
	{
		printf("%s:%d: warning: %s\n", assembly_file_name, line_num, warning_msg);
	}
	else
	{
		printf("%s: warning: %s\n", assembly_file_name, warning_msg);
	}
}

void warning_msg_invalid_line(int line_num)
{
	warning_msg("ЧĴС", line_num);
}

void warning_msg_unref_symbol(const char* symbol, int line_num)
{
	sprintf(formated_msg, " %s δá", symbol);
	warning_msg(formated_msg, line_num);
}

// жǷֿͷǸſͷģΪ
int is_immediate(const char* token)
{
	return (isdigit(token[0]) || '-' == token[0]) ? 1 : 0;
}


// ָ
enum
{
	OT_REGISTER_R0				// $r0
	,OT_REGISTER_R1				// $r1
	,OT_REGISTER_R2				// $r2
	,OT_REGISTER_R3				// $r3
	,OT_IMMEDIATE				// 
	,OT_SYMBOL					// 
};

// õָ
unsigned long get_operand_type(const char* op)
{
	unsigned long op_type;

	if(stricmp(op, r0_register_keyword) == 0)
	{
		op_type = OT_REGISTER_R0;
	}
	else if(stricmp(op, r1_register_keyword) == 0)
	{
		op_type = OT_REGISTER_R1;
	}
	else if(stricmp(op, r2_register_keyword) == 0)
	{
		op_type = OT_REGISTER_R2;
	}
	else if(stricmp(op, r3_register_keyword) == 0)
	{
		op_type = OT_REGISTER_R3;
	}
	else if(is_immediate(op))
	{
		op_type = OT_IMMEDIATE;
	}
	else
	{
		op_type = OT_SYMBOL;
	}

	return op_type;
}

//  r? Ĵõһ
char get_machine_code_from_r(unsigned long op_type)
{
	return (char)(op_type - OT_REGISTER_R0);
}

// õһ롣ע⣬ʹøԷֵǴŵ 8 λ char
char get_machine_code_from_immediate(const char* immediate)
{
	char* end;
	int start_index = (immediate[0] == '-' ? 1 : 0);

	int base = (immediate[start_index] == '0' && (immediate[start_index + 1] == 'x' || immediate[start_index + 1] == 'X')) ? 16 : 10;
	return (char)strtol(immediate, &end, base);
}

// ضλһضλϢ
void add_reallocate(const char* symbol, int line_num, const char* instr_key_word)
{
	reallocate_table[reallocate_count].address = machine_code_address;
	strcpy(reallocate_table[reallocate_count].symbol_name, symbol);
	strcpy(reallocate_table[reallocate_count].instr_key_word, instr_key_word);
	reallocate_table[reallocate_count].line_num = line_num;
	reallocate_count++;
}

// жһǷlwswָĵڶͣʾַƫƣɸ
int is_lw_sw_instr_operand(const char* op)
{
	int i;

	// һַǺ
	if (op[strlen(op) - 1] != ')')
	{
		return 0;
	}

	// ڶַ0,1,2,3
	if (op[strlen(op) - 2] != '0'
		&& op[strlen(op) - 2] != '1'
		&& op[strlen(op) - 2] != '2'
		&& op[strlen(op) - 2] != '3')
	{
		return 0;
	}

	// ַr
	if (op[strlen(op) - 3] != 'r')
	{
		return 0;
	}

	// ĸַ$
	if (op[strlen(op) - 4] != '$')
	{
		return 0;
	}

	// ַ'('
	if (op[strlen(op) - 5] != '(')
	{
		return 0;
	}

	// 26ַ
	// һַΪ-ʾ
	if (op[0] == '-')
	{
		for(i=1; i<(int)strlen(op)-5; i++)
		{
			if(!isdigit(op[i]))
			{
				return 0;
			}
		}
	}
	else
	{
		for(i=0; i<(int)strlen(op)-5; i++)
		{
			if(!isdigit(op[i]))
			{
				return 0;
			}
		}
	}
	
	return 1;

}

//  r? Ĵõһ
char get_machine_code_from_operand(const char* operand)
{
	if (operand[strlen(operand) - 2] == '0')
	{
		return (char)0;
	}
	else if (operand[strlen(operand) - 2] == '1')
	{
		return (char)1;
	}
	else if (operand[strlen(operand) - 2] == '2')
	{
		return (char)2;
	}
	else if (operand[strlen(operand) - 2] == '3')
	{
		return (char)3;
	}
	else
	{
		return (char)(-1);
	}
}

//////////////////////////////////////////////////////////////////////////
// Rָ
//

// or $rd, $rs, $rt
void parse_or(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(or_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(or_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// and $rd, $rs, $rt
void parse_and(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(and_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x01;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(and_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// add $rd, $rs, $rt
void parse_add(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(add_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
	   && op1_type <= OT_REGISTER_R3 
	   && op2_type >= OT_REGISTER_R0 
	   && op2_type <= OT_REGISTER_R3
	   && op3_type >= OT_REGISTER_R0 
	   && op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;
		
		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x02;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(add_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// sub $rd, $rs, $rt
void parse_sub(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(sub_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x03;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(sub_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// sllv $rd, $rs, $rt
void parse_sllv(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(sllv_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x04;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(sllv_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// srlv $rd, $rs, $rt
void parse_srlv(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(srlv_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x05;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(srlv_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// srav $rd, $rs, $rt
void parse_srav(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(srav_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x06;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(srav_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// slt $rd, $rs, $rt
void parse_slt(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(slt_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 2~0,3λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x07;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(slt_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// xor $rd, $rs, $rt
void parse_xor(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(xor_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 3~0,4λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x08;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(xor_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// nor $rd, $rs, $rt
void parse_nor(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt, rd;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(nor_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type >= OT_REGISTER_R0 
		&& op3_type <= OT_REGISTER_R3)
	{
		// 15~124λ붼0

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op3_type);

		machine_code[machine_code_address] = rs | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 3~0,4λ㷽ʽ		
		machine_code[machine_code_address] = rd | 0x09;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(nor_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// jr $rs
void parse_jr(int line_num)
{
	char *op;
	char rs;
	unsigned long op_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op = strtok(NULL, delimit_char_comma);

	if(NULL == op)
	{
		error_msg_miss_op(jr_instruction_keyword, line_num);
	}

	op_type = get_operand_type(op);
	if(op_type >= OT_REGISTER_R0 && op_type <= OT_REGISTER_R3 )
	{
		// 15~124λʾʮ1

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op_type);
		rs = rs << 2;

		machine_code[machine_code_address] = 0x10 | rs;
		machine_code_address++;


		// 8λ		
		machine_code[machine_code_address] = 0x00;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(jr_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// jalr $rs
void parse_jalr(int line_num)
{
	char *op;
	char rs;
	unsigned long op_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op = strtok(NULL, delimit_char_comma);

	if(NULL == op)
	{
		error_msg_miss_op(jalr_instruction_keyword, line_num);
	}

	op_type = get_operand_type(op);
	if(op_type >= OT_REGISTER_R0 && op_type <= OT_REGISTER_R3 )
	{
		// 15~124λʾʮ2

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op_type);
		rs = rs << 2;

		machine_code[machine_code_address] = 0x20 | rs;
		machine_code_address++;


		// 8λ		
		machine_code[machine_code_address] = 0x00;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(jalr_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// sll $rd, $rt, shamt
void parse_sll(int line_num)
{
	char *op1, *op2, *op3;
	char rd, rt, shamt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(sll_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type == OT_IMMEDIATE)
	{
		// 15~124λʾʮ12

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op2_type);

		machine_code[machine_code_address] = 0xC0 | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 5~4,2λλĿ
		shamt = get_machine_code_from_immediate(op3);

		// 3~0,4λ㷽ʽ		
		machine_code[machine_code_address] = rd | shamt | 0x04;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(sll_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// srl $rd, $rt, shamt
void parse_srl(int line_num)
{
	char *op1, *op2, *op3;
	char rd, rt, shamt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(srl_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3
		&& op3_type == OT_IMMEDIATE)
	{
		// 15~124λʾʮ13

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op2_type);

		machine_code[machine_code_address] = 0xD0 | rt;
		machine_code_address++;

		// 7~6,2λrdĴ
		rd = get_machine_code_from_r(op1_type);
		rd = rd << 6;

		// 5~4,2λλĿ
		shamt = get_machine_code_from_immediate(op3);

		// 3~0,4λ㷽ʽ		
		machine_code[machine_code_address] = rd | shamt | 0x05;
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(srl_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

//////////////////////////////////////////////////////////////////////////
// Iָ
//

// ori $rt, $rs, imm
void parse_ori(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(ori_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_IMMEDIATE)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op1_type);

		machine_code[machine_code_address] = 0x30 | rs | rt;
		machine_code_address++;

		// 7~0,8λ
		machine_code[machine_code_address] = get_machine_code_from_immediate(op3);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(ori_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}


// andi $rt, $rs, imm
void parse_andi(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(andi_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_IMMEDIATE)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op1_type);

		machine_code[machine_code_address] = 0x40 | rs | rt;
		machine_code_address++;

		// 7~0,8λ
		machine_code[machine_code_address] = get_machine_code_from_immediate(op3);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(andi_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// addi $rt, $rs, imm
void parse_addi(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(addi_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_IMMEDIATE)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op2_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op1_type);

		machine_code[machine_code_address] = 0x50 | rs | rt;
		machine_code_address++;

		// 7~0,8λ
		machine_code[machine_code_address] = get_machine_code_from_immediate(op3);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(addi_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// lw $rt, offset($rs)
void parse_lw(int line_num)
{
	int i;
	char *op1, *op2;
	char immediate[8];
	char rs, rt;
	unsigned long op1_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(lw_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& is_lw_sw_instr_operand(op2))
	{
		rs = get_machine_code_from_operand(op2);
		rs = rs << 2;

		// һַõһʮ
		for(i=0; i<(int)strlen(op2)-5; i++)
		{
			immediate[i] = op2[i];
		}

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op1_type);

		machine_code[machine_code_address] = 0x60 | rs | rt;
		machine_code_address++;

		// 7~0,8λ
		machine_code[machine_code_address] = get_machine_code_from_immediate(immediate);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(lw_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// sw $rt, offset($rs)
void parse_sw(int line_num)
{
	int i;
	char *op1, *op2;
	char immediate[8];
	char rs, rt;
	unsigned long op1_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(sw_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& is_lw_sw_instr_operand(op2))
	{
		rs = get_machine_code_from_operand(op2);
		rs = rs << 2;

		// һַõһʮ
		for(i=0; i<(int)strlen(op2)-5; i++)
		{
			immediate[i] = op2[i];
		}

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op1_type);

		machine_code[machine_code_address] = 0x70 | rs | rt;
		machine_code_address++;

		// 7~0,8λ
		machine_code[machine_code_address] = get_machine_code_from_immediate(immediate);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(sw_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// beq $rs, $rt, label
void parse_beq(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(beq_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_SYMBOL)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op1_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op2_type);

		machine_code[machine_code_address] = 0x80 | rs | rt;
		machine_code_address++;

		// 7~0,зƫoffset
		add_reallocate(op3, line_num, beq_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(beq_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// bne $rs, $rt, label
void parse_bne(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(bne_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_SYMBOL)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op1_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op2_type);

		machine_code[machine_code_address] = 0x90 | rs | rt;
		machine_code_address++;

		// 7~0,зƫoffset
		add_reallocate(op3, line_num, bne_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(bne_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// bgt $rs, $rt, label
void parse_bgt(int line_num)
{
	char *op1, *op2, *op3;
	char rs, rt;
	unsigned long op1_type, op2_type, op3_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);
	op3 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2 || NULL == op3)
	{
		error_msg_miss_op(bgt_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);
	op3_type = get_operand_type(op3);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type >= OT_REGISTER_R0 
		&& op2_type <= OT_REGISTER_R3 
		&& op3_type == OT_SYMBOL)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op1_type);
		rs = rs << 2;

		// 9~8,2λrtĴ
		rt = get_machine_code_from_r(op2_type);

		machine_code[machine_code_address] = 0xA0 | rs | rt;
		machine_code_address++;

		// 7~0,зƫoffset
		add_reallocate(op3, line_num, bgt_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(bgt_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// bltz $rs, label
void parse_bltz(int line_num)
{
	char *op1, *op2;
	char rs;
	unsigned long op1_type, op2_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char_comma);

	if(NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(bltz_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type == OT_SYMBOL)
	{
		// 15~124λʾʮ14

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op1_type);
		rs = rs << 2;

		machine_code[machine_code_address] = 0xE0 | rs;
		machine_code_address++;

		// 7~0,зƫoffset
		add_reallocate(op2, line_num, bltz_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(bltz_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}


//////////////////////////////////////////////////////////////////////////
// Jָ
// 
// jump label
void parse_jump(int line_num)
{
	char *op;
	unsigned long op_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op = strtok(NULL, delimit_char);

	if(NULL == op)
	{
		error_msg_miss_op(jump_instruction_keyword, line_num);
	}

	op_type = get_operand_type(op);

	if(OT_SYMBOL == op_type)
	{
		// jump label
		machine_code[machine_code_address] = 0xB0;
		machine_code_address++;

		// ضλ
		add_reallocate(op, line_num, jump_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(jump_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// jal label
void parse_jal(int line_num)
{
	char *op;
	unsigned long op_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op = strtok(NULL, delimit_char);

	if(NULL == op)
	{
		error_msg_miss_op(jal_instruction_keyword, line_num);
	}

	op_type = get_operand_type(op);

	if(OT_SYMBOL == op_type)
	{
		// jal label
		machine_code[machine_code_address] = 0xF0;
		machine_code_address++;

		// ضλ
		add_reallocate(op, line_num, jal_instruction_keyword);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(jal_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

//////////////////////////////////////////////////////////////////////////
// DISPָ
//
// DISP $rs, imm
void parse_disp(int line_num)
{
	char *op1, *op2;
	char rs;
	unsigned long op1_type, op2_type;

	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char);

	if(NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(jal_instruction_keyword, line_num);
	}

	op1_type = get_operand_type(op1);
	op2_type = get_operand_type(op2);

	if(op1_type >= OT_REGISTER_R0 
		&& op1_type <= OT_REGISTER_R3 
		&& op2_type == OT_IMMEDIATE)
	{
		// 15~124λ

		// 11~10,2λrsĴ
		rs = get_machine_code_from_r(op1_type);
		rs = rs << 2;

		machine_code[machine_code_address] = 0x01 | rs;
		machine_code_address++;

		// DISPֶָֻ01ȡֵѡ0ʾ1ʾʾrsе
		machine_code[machine_code_address] = get_machine_code_from_immediate(op2);
		machine_code_address++;
	}
	else
	{
		error_msg_wrong_op(jal_instruction_keyword, line_num);
	}

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

//////////////////////////////////////////////////////////////////////////
// haltָ
//
// halt
void parse_halt(int line_num)
{
	if(assembler_state != AS_TEXT)
	{
		warning_msg_invalid_line(line_num);
		return;
	}

	machine_code[machine_code_address] = 0xC0;
	machine_code_address++;

	machine_code[machine_code_address] = 0x00;
	machine_code_address++;

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}



//////////////////////////////////////////////////////////////////////////
//
// űһ
void add_symbol(const char* symbol, int line_num)
{
	int i;

	// Ʋظ
	for(i=0; i<symbol_count; i++)
	{
		if(stricmp(symbol, symbol_table[i].name) == 0)
		{
			error_msg_same_symbol(symbol, line_num, symbol_table[i].line_num);
		}
	}

	// 
	if(symbol_count == MAX_SYMBOL_COUNT)
	{
		sprintf(formated_msg, "̫ķšԶ %d š", MAX_SYMBOL_COUNT);
		error_msg(formated_msg, line_num);
	}

	// ӷ
	strcpy(symbol_table[symbol_count].name, symbol);
	symbol_table[symbol_count].address = machine_code_address;
	symbol_table[symbol_count].line_num = line_num;
	symbol_count++;
}

// 
void parse_symbol(const char* symbol_with_colon, int line_num)
{
	char symbol[MAX_SYMBOL_LENGTH];
	char* token;

	// ɾĩβð
	strcpy(symbol, symbol_with_colon);
	symbol[strlen(symbol) - 1] = 0;

	if(AS_TEXT == assembler_state)
	{
		// еıΪš¼űУ롣
		add_symbol(symbol, line_num);

		// ű뵥ռһУ򱨴
		if (strtok(NULL, delimit_char) != NULL)
		{
			error_msg("ű뵥ռһС", line_num);
		}
	}
	else if(AS_DATA == assembler_state)
	{
		// ݶеıΪšһ԰ֽݡ¼űУ롣
		add_symbol(symbol, line_num);

		while((token = strtok(NULL, delimit_char)) != NULL)
		{
			if(!is_immediate(token))
			{
				error_msg_wrong_data(token, line_num);
			}

			machine_code[machine_code_address] = get_machine_code_from_immediate(token);
			machine_code_address++;
			symbol_table[symbol_count - 1].machine_code_count++;
		}
	}
	else
	{
		warning_msg_invalid_line(line_num);
	}
}

// οʼ־
void parse_code_section_keyword(int line_num)
{
	// α־
	if(AS_DATA == assembler_state)
	{
		error_msg("βܶݶεĺ档", line_num);
	}
	else if(AS_TEXT == assembler_state)
	{
		error_msg("ظĴΡ", line_num);
	}

	assembler_state = AS_TEXT;
}

// ݶοʼ־
void parse_data_section_keyword(int line_num)
{
	// ݶα־
	if(AS_DATA == assembler_state)
	{
		error_msg("ظݶΡ", line_num);
	}
	else if(AS_BEGIN == assembler_state)
	{
		error_msg("ݶβܶڴεǰ档", line_num);
	}

	assembler_state = AS_DATA;
}

// ؼֺͽĶӦϵ
typedef void (*PARSE_FUNCTION)(int line_num);
struct KEYWORD_FUNCTION_ENTRY
{
	const char** keyword;
	PARSE_FUNCTION parse_function;
};

//
// 뽫ؼּıСӶʹáıģʽ
//
struct KEYWORD_FUNCTION_ENTRY keyword_function_table[] =
{
	 {	NULL,								NULL						}	// δ

	,{	&code_section_keyword,				parse_code_section_keyword	}
	,{	&data_section_keyword,				parse_data_section_keyword	}

	,{	&or_instruction_keyword,			parse_or					}
	,{	&and_instruction_keyword,			parse_and					}
	,{	&add_instruction_keyword,			parse_add					}
	,{	&sub_instruction_keyword,			parse_sub					}
	,{	&sllv_instruction_keyword,			parse_sllv					}
	,{	&srlv_instruction_keyword,			parse_srlv					}	
	,{	&srav_instruction_keyword,			parse_srav					}
	,{	&slt_instruction_keyword,			parse_slt					}

	,{	&jr_instruction_keyword,			parse_jr					}
	,{	&jalr_instruction_keyword,			parse_jalr					}
	,{	&xor_instruction_keyword,			parse_xor					}
	,{	&nor_instruction_keyword,			parse_nor					}
	,{	&srl_instruction_keyword,			parse_srl					}	
	,{	&sra_instruction_keyword,			NULL						}
	,{	&sll_instruction_keyword,			parse_sll					}

	,{	&ori_instruction_keyword,			parse_ori					}
	,{	&andi_instruction_keyword,			parse_andi					}
	,{	&addi_instruction_keyword,			parse_addi					}
	,{	&lw_instruction_keyword,			parse_lw					}
	,{	&sw_instruction_keyword,			parse_sw					}
	,{	&beq_instruction_keyword,			parse_beq					}
	,{	&bne_instruction_keyword,			parse_bne					}
	,{	&bgt_instruction_keyword,			parse_bgt					}

	,{	&bltz_instruction_keyword,			parse_bltz					}
	,{	&bgez_instruction_keyword,			NULL						}

	,{	&jump_instruction_keyword,			parse_jump					}
	,{	&jal_instruction_keyword,			parse_jal					}
	
	
	,{	&r0_register_keyword,				NULL						}
	,{	&r1_register_keyword,				NULL						}
	,{	&r2_register_keyword,				NULL						}
	,{	&r3_register_keyword,				NULL						}
	,{	&ra_register_keyword,				NULL						}
	,{	&t0_register_keyword,				NULL						}
};

// жǷһؼ֡0ǹؼ֣ط0ǹؼ֣ҷֵǹؼڱе±ꡣ
int match_keyword(const char* token)
{
	int i;

	for(i=1; i<sizeof(keyword_function_table)/sizeof(keyword_function_table[0]); i++)
	{
		if(stricmp(token, *keyword_function_table[i].keyword) == 0)
		{
			return i;
		}
	}

	return 0;
}

// жǷһ
int is_symbol(const char* token, int line_num)
{
	int i;
	char symbol_name[MAX_SYMBOL_LENGTH];

	// һַð
	if(token[strlen(token) - 1] != ':')
	{
		return 0;
	}

	// һַĸ»
	if(token[0] != '_' && !isalpha(token[0]))
	{
		return 0;
	}

	// ַĸ֡»
	for(i=0; i<(int)strlen(token)-2; i++)
	{
		if(token[i] != '_' && !isalpha(token[i]) && !isdigit(token[i]))
		{
			return 0;
		}
	}

	// ؼͬ
	strcpy(symbol_name, token);
	symbol_name[strlen(symbol_name) - 1] = 0;
	if(match_keyword(symbol_name) != 0)
	{
		error_msg_keyword_symbol(symbol_name, line_num);
	}

	return 1;
}

// 汾Ϣ
void version_msg()
{
	printf(
		"Engintime 16λ MIPS ָ [汾 2.0]\n"
		"Ȩ (c) 2008-2018 ӢʱƼ޹˾Ȩ\n"
		);
}

// Ϣ
void help_msg()
{
	printf(
		"Engintime 16λ MIPS ָ\n\n"
		"÷:\n\n"
		"  dmasm.exe assembly_file_name [options]\n\n"
		"ѡ:\n\n"
		"  -g debug_file_name\tָɵĵϢļ·\n"
		"  -h\t\t\tӡ˰Ϣ\n"
		"  -l list_file_name\tָɵбļ·\n"
		"  -o target_file_name\tָɵĿļ·δָĬ a.obj ļ\n"
		"  -v\t\t\tӡ汾Ϣ\n"
		);

	printf("\n");

	version_msg();

	exit(1);
}

void argument_error_msg()
{
	printf("в\n\n");
	help_msg();
}

// ûв
void process_argument(int argc, char* argv[])
{
	int i;

	// argv[0]  "easm.exe"ԿԺԡ
	for(i=1; i<argc; i++)
	{
		if(strcmp(argv[i], "-v") == 0)
		{
			version_msg();
			exit(1);
		}
		else if(strcmp(argv[i], "-h") == 0)
		{
			help_msg();
		}
		else if(strcmp(argv[i], "-o") == 0)
		{
			if(i + 1 < argc)
			{
				i++;
				target_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if(strcmp(argv[i], "-l") == 0)
		{
			if(i + 1 < argc)
			{
				i++;
				list_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if(strcmp(argv[i], "-g") == 0)
		{
			if(i + 1 < argc)
			{
				i++;
				dbg_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if(NULL == assembly_file_name && argv[i][0] != '-')
		{
			// ĻԴļ·
			assembly_file_name = argv[i];
		}
		else
		{
			argument_error_msg();
		}
	}

	//
	// вûָĻļʹӡϢ˳
	//
	if(NULL == assembly_file_name)
	{
		printf("вûָԴļ·\n");
		help_msg();
	}
}

// һַдļСȽַдļȻַе
// ÿַдļַĩβ 0.
void write_string_to_binary_file(const char* str, FILE* fp)
{
	int str_length;

	if(str != NULL)
	{
		str_length = strlen(str);
		fwrite(&str_length, 1, sizeof(str_length), fp);
		fwrite(str, 1, str_length, fp);
	}
	else
	{
		str_length = 0;
		fwrite(&str_length, 1, sizeof(str_length), fp);
	}
}


int main(int argc, char* argv[])
{   
	FILE* fp;
	char* token;
	char line[MAX_LINE_LENGTH];
	int i, j;	
	int line_num = 1;	// кŴӵһпʼ
	int keyword_index;
	unsigned long base_PC, offset_PC;

	//
	// в
	//
	process_argument(argc, argv);

	//
	// 򿪻Դļ
	//
	fp = fopen(assembly_file_name, "r");
	if(NULL == fp)
	{
		printf("޷Դļ %s\n", assembly_file_name);
		return 1;
	}

	//////////////////////////////////////////////////////////////////////////
	// һɨ

	version_msg();
	printf("\nڻ %s...\n", assembly_file_name);

	//
	// һζȡһıͬʱ¼еĴϢ
	//
	while(fgets(line, sizeof(line), fp) != NULL)
	{
		//
		// һдϢ¼ݿ
		//
		strcpy(line_database[line_count].line_string, line);
		line_database[line_count].line_num = line_num;
		line_database[line_count].address = machine_code_address;

		//
		// еעͰ
		//
		line[strcspn(line, ";")] = 0;

		//
		// ʼ
		//
		token = strtok(line, delimit_char);
		if(NULL == token)
		{
			// ǿУκδ
		}
		else if((keyword_index = match_keyword(token)) != 0
			&& keyword_function_table[keyword_index].parse_function != NULL)
		{
			// ݹؼֽӦĴ
			keyword_function_table[keyword_index].parse_function(line_num);
		}
		else if(is_symbol(token, line_num))
		{
			// 
			parse_symbol(token, line_num);
		}
		else
		{
			error_msg("޷ʶĴС", line_num);
		}

		//
		// ݿϢ
		//
		line_database[line_count].machine_code_count = machine_code_address - machine_code_old_address;
		machine_code_old_address = machine_code_address;

		//
		// ¼˻Ĵ
		//
		if(line_database[line_count].machine_code_count != 0)
		{
			machine_code_line_count++;
		}

		//
		// к
		//
		line_count++;
		line_num++;

		if(line_count == MAX_LINE_COUNT)
		{
			sprintf(formated_msg, "ļеĴйֻ࣬ %d д롣", MAX_LINE_COUNT);
			error_msg(formated_msg, -1);
		}
	}

	fclose(fp);

	//////////////////////////////////////////////////////////////////////////
	// ڶɨ

	//
	// ݷűضλ
	//
	for(i=0; i<reallocate_count; i++)
	{
		for(j=0; j<symbol_count; j++)
		{
			if(stricmp(symbol_table[j].name, reallocate_table[i].symbol_name) == 0)
			{
				if (stricmp(beq_instruction_keyword, reallocate_table[i].instr_key_word) == 0
					|| stricmp(bne_instruction_keyword, reallocate_table[i].instr_key_word) == 0
					|| stricmp(bgt_instruction_keyword, reallocate_table[i].instr_key_word) == 0
					|| stricmp(bltz_instruction_keyword, reallocate_table[i].instr_key_word) == 0)
				{
					// תָ
					// Ϊָĵڶֽڱ룬Աŵַȼ1ָָ
					// Ȼ2ָһָΪƫPC+2ĵַ
					//
					machine_code[reallocate_table[i].address] = (BYTE)((symbol_table[j].address - (reallocate_table[i].address - 1 + 2))/2);
					symbol_table[j].ref_count++;
				}
				else if (stricmp(jump_instruction_keyword, reallocate_table[i].instr_key_word) == 0
						|| stricmp(jal_instruction_keyword, reallocate_table[i].instr_key_word) == 0)
				{
					//
					// תָ
					//
					
					// ȡתַָ4λ12λΪ0Ϊתָƫƻַ
					base_PC = reallocate_table[i].address & 0xf000;

					// ȡŵַڻַƫƣȡеĵ12λΪЧλ
					offset_PC = (symbol_table[j].address - base_PC) & 0x0fff;
					
					// תָ
					machine_code[reallocate_table[i].address - 1] = (BYTE)(machine_code[reallocate_table[i].address - 1] | offset_PC >> 8);
					machine_code[reallocate_table[i].address] = (BYTE)(offset_PC/2);
					
					symbol_table[j].ref_count++;
				}
				

				break;
			}
		}

		if(j == symbol_count)
		{
			// ضλʹõķڷűδ壬
			sprintf(formated_msg, "ʹδķ %s", reallocate_table[i].symbol_name);
			error_msg(formated_msg, reallocate_table[i].line_num);
		}
	}

	//
	// δõķţϢ
	//
	for(i=0; i<symbol_count; i++)
	{
		if(0 == symbol_table[i].ref_count)
		{
			warning_msg_unref_symbol(symbol_table[i].name, symbol_table[i].line_num);
		}
	}

	//////////////////////////////////////////////////////////////////////////
	// ļ

	//
	// дļ
	//
	if(NULL == target_file_name)
	{
		target_file_name = "a.obj";
	}

	fp = fopen(target_file_name, "wb");
	if(NULL == fp)
	{
		printf("޷ļ %s\n", target_file_name);
		return 1;
	}

	fwrite(machine_code, 1, machine_code_address, fp);

	fclose(fp);

	printf("\nĿļ %s\n", target_file_name);

	//
	// ݿеϢдбļ
	//
	if(list_file_name != NULL)
	{
		fp = fopen(list_file_name, "w");
		if(NULL == fp)
		{
			printf("޷бļ %s\n", list_file_name);
			return 1;
		}

		for(i=0; i<line_count; i++)
		{
			// к
			fprintf(fp, "%04d    ", line_database[i].line_num);

			// ַͻ
			if(line_database[i].machine_code_count > 0)
			{
				fprintf(fp, "%02X    ", line_database[i].address);

				for(j=0; j<line_database[i].machine_code_count; j++)
				{
					// ȷÿдֽڵĻ
					if(j != 0 && j % 2 == 0)
					{
						if(2 == j)
						{
							fprintf(fp, "              ");
						}
						else
						{
							fprintf(fp, "\n        ");
						}
					}

					fprintf(fp, "%02X ", machine_code[line_database[i].address + j]);

					if(1 == j)
					{
						fprintf(fp, "  ");
						fprintf(fp, line_database[i].line_string);
					}
				}

				if(1 == j)
				{
					fprintf(fp, "     ");
					fprintf(fp, line_database[i].line_string);
				}
				else if(j > 2)
				{
					fprintf(fp, "\n");
				}
			}
			else
			{
				fprintf(fp, "              ");

				// Դ
				fprintf(fp, line_database[i].line_string);
			}
		}

		fclose(fp);

		printf("бļ %s\n", list_file_name);
	}

	//
	// ݿеϢдƵĵϢļ
	//
	// ϢĻʽΪ
	// ħ4ֽڣ̶ɸı
	// 汾ţ4ֽڣ̶ɸı
	// Դļ·ַȣ4ֽڣ
	// Դļ·ַַβ0
	// бļ·ַȣ4ֽڣ
	// бļ·ַַβ0
	//
	// ݿԪص4ֽڣ
	// ݿеԪ
	//
	// űԪص4ֽڣ
	// űеԪ
	//

	if(dbg_file_name != NULL)
	{
		fp = fopen(dbg_file_name, "wb");
		if(NULL == fp)
		{
			printf("޷򿪵Ϣļ %s\n", dbg_file_name);
			return 1;
		}

		// ħ
		fwrite(&dbg_file_magic, 1, sizeof(dbg_file_magic), fp);

		// 汾
		fwrite(&dbg_file_version, 1, sizeof(dbg_file_version), fp);

		// Դļ·
		write_string_to_binary_file(assembly_file_name, fp);

		// бļ·
		write_string_to_binary_file(list_file_name, fp);

		// ݿеԪ
		fwrite(&machine_code_line_count, 1, sizeof(machine_code_line_count), fp);
		for(i=0; i<line_count; i++)
		{
			// ûвĴ
			if(0 == line_database[i].machine_code_count)
			{
				continue;
			}

			fwrite(&line_database[i].line_num, 1, sizeof(unsigned long), fp);
			fwrite(&line_database[i].address, 1, sizeof(unsigned long), fp);
			fwrite(&line_database[i].machine_code_count, 1, sizeof(int), fp);
			fwrite(&line_database[i].flag, 1, sizeof(unsigned long), fp);
		}

		// űеԪ
		fwrite(&symbol_count, 1, sizeof(symbol_count), fp);
		for(i=0; i<symbol_count; i++)
		{
			write_string_to_binary_file(symbol_table[i].name, fp);
			fwrite(&symbol_table[i].address, 1, sizeof(unsigned long), fp);
			fwrite(&symbol_table[i].machine_code_count, 1, sizeof(int), fp);
			fwrite(&symbol_table[i].line_num, 1, sizeof(int), fp);
		}

		fclose(fp);

		printf("ɵϢļ %s\n", dbg_file_name);
	}

	return 0;
}


